package com.vp.plugin.sample.referencebyaddress.actions;

import java.awt.event.*;

import com.vp.plugin.*;
import com.vp.plugin.action.*;
import com.vp.plugin.model.*;
import com.vp.plugin.model.factory.*;

public class AddReferenceToUseCaseActionController implements VPContextActionController {
	
	private String _address; // UseCase.address

	public void performAction(VPAction aAction, VPContext aContext, ActionEvent aE) {
		
		IModelElement lModelElement = aContext.getModelElement();
		if (lModelElement != null) {
			
			IUseCase lUseCase = null;
			
			// if UseCase not exists, create it.
			if (_address != null) {
				IProject lProject = ApplicationManager.instance().getProjectManager().getProject();
				
				IModelElement lReferencedModelElement = lProject.getModelElementByAddress(_address);
				if (lReferencedModelElement != null && lReferencedModelElement instanceof IUseCase) {
					lUseCase = (IUseCase) lReferencedModelElement;
				}
			}
			
			if (lUseCase == null) {
				lUseCase = IModelElementFactory.instance().createUseCase();
				_address = lUseCase.getAddress();
			}
			
			lModelElement.setDocumentation("Reference to \0"+_address+"\0");
		}
		
	}

	public void update(VPAction aAction, VPContext aContext) {
		aAction.setEnabled(aContext.getModelElement() != null);
	}

}
